=== debian/changelog ===
bedops (2.4.41+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Docs: added patch removing the use of intersphinx, it is unneeded
    and had the wrong layout. Closes: #1090091
  * d/control: need tcsh for the man pages
  * Standards-Version: 4.7.0 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 17 Dec 2024 17:40:45 +0100

bedops (2.4.41+dfsg-2) unstable; urgency=medium

  * d/control: drop python3-distutils dependency. (Closes: #1065834)
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.6.2.

 -- Étienne Mollier <emollier@debian.org>  Sun, 10 Mar 2024 15:40:54 +0100
