=== debian/control ===
Source: bedops
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               help2man,
               libbz2-dev,
               libjansson-dev,
               zlib1g-dev,
               tcsh
Build-Depends-Indep: sphinx-common,
                     dh-sequence-sphinxdoc,
                     libjs-mathjax,
                     python3-sphinx
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/bedops
Vcs-Git: https://salsa.debian.org/med-team/bedops.git
Homepage: https://github.com/bedops/bedops
Rules-Requires-Root: no

Package: bedops
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3,
         tcsh
Description: high-performance genomic feature operations
 BEDOPS is a suite of tools to address common questions raised in genomic
 studies, mostly with regard to overlap and proximity relationships between
 data sets.
 It aims to be scalable and flexible, facilitating the efficient and accurate
 analysis and management of large-scale genomic data.

Package: bedops-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-sphinxdoc,
         libjs-mathjax
Multi-Arch: foreign
Description: high-performance genomic feature operations (documentation)
 BEDOPS is a suite of tools to address common questions raised in genomic
 studies, mostly with regard to overlap and proximity relationships between
 data sets.
 It aims to be scalable and flexible, facilitating the efficient and accurate
 analysis and management of large-scale genomic data.
 .
 This package contains the BEDOPS documentation.
