## bedops 2.4.42%2Bdfsg

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/bedops-$1\.tar\.gz/" \
  https://github.com/bedops/bedops/tags .*/v?(\d\S+)\.tar\.gz
